/**
 * @license
 * Copyright 2019 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import{util,dispose,loadModel,model,tidy,zeros,Tensor,tensor4d,unstack,scalar,sequential,layers,io,tensor3d,data,oneHot,tensor1d,stack,tensor2d,tensor,ENV,moments,gather}from"@tensorflow/tfjs";var extendStatics=function(e,t){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(e,t)};function __extends(e,t){function r(){this.constructor=e}extendStatics(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}function __awaiter(e,t,r,a){return new(r||(r=Promise))(function(n,s){function i(e){try{l(a.next(e))}catch(e){s(e)}}function o(e){try{l(a.throw(e))}catch(e){s(e)}}function l(e){e.done?n(e.value):new r(function(t){t(e.value)}).then(i,o)}l((a=a.apply(e,t||[])).next())})}function __generator(e,t){var r,a,n,s,i={label:0,sent:function(){if(1&n[0])throw n[1];return n[1]},trys:[],ops:[]};return s={next:o(0),throw:o(1),return:o(2)},"function"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s;function o(s){return function(o){return function(s){if(r)throw new TypeError("Generator is already executing.");for(;i;)try{if(r=1,a&&(n=2&s[0]?a.return:s[0]?a.throw||((n=a.return)&&n.call(a),0):a.next)&&!(n=n.call(a,s[1])).done)return n;switch(a=0,n&&(s=[2&s[0],n.value]),s[0]){case 0:case 1:n=s;break;case 4:return i.label++,{value:s[1],done:!1};case 5:i.label++,a=s[1],s=[0];continue;case 7:s=i.ops.pop(),i.trys.pop();continue;default:if(!(n=(n=i.trys).length>0&&n[n.length-1])&&(6===s[0]||2===s[0])){i=0;continue}if(3===s[0]&&(!n||s[1]>n[0]&&s[1]<n[3])){i.label=s[1];break}if(6===s[0]&&i.label<n[1]){i.label=n[1],n=s;break}if(n&&i.label<n[2]){i.label=n[2],i.ops.push(s);break}n[2]&&i.ops.pop(),i.trys.pop();continue}s=t.call(e,i)}catch(e){s=[6,e],a=0}finally{r=n=0}if(5&s[0])throw s[1];return{value:s[0]?s[1]:void 0,done:!0}}([s,o])}}}function __values(e){var t="function"==typeof Symbol&&e[Symbol.iterator],r=0;return t?t.call(e):{next:function(){return e&&r>=e.length&&(e=void 0),{value:e&&e[r++],done:!e}}}}function __read(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var a,n,s=r.call(e),i=[];try{for(;(void 0===t||t-- >0)&&!(a=s.next()).done;)i.push(a.value)}catch(e){n={error:e}}finally{try{a&&!a.done&&(r=s.return)&&r.call(s)}finally{if(n)throw n.error}}return i}function __spread(){for(var e=[],t=0;t<arguments.length;t++)e=e.concat(__read(arguments[t]));return e}function loadMetadataJson(e){return __awaiter(this,void 0,void 0,function(){var t,r,a,n;return __generator(this,function(s){switch(s.label){case 0:return t="http://",r="https://",a="file://",0!==e.indexOf(t)&&0!==e.indexOf(r)?[3,3]:[4,fetch(e)];case 1:return[4,s.sent().json()];case 2:return[2,s.sent()];case 3:if(0===e.indexOf(a))return n=require("fs"),[2,JSON.parse(n.readFileSync(e.slice(a.length),{encoding:"utf-8"}))];throw new Error("Unsupported URL scheme in metadata URL: "+e+". Supported schemes are: http://, https://, and (node.js-only) file://");case 4:return[2]}})})}var EPSILON=null;function normalize(e){return null==EPSILON&&(EPSILON=ENV.get("EPSILON")),tidy(function(){var t=moments(e),r=t.mean,a=t.variance;return e.sub(r).div(a.sqrt().add(EPSILON))})}function getAudioContextConstructor(){return window.AudioContext||window.webkitAudioContext}function getAudioMediaStream(){return __awaiter(this,void 0,void 0,function(){return __generator(this,function(e){switch(e.label){case 0:return[4,navigator.mediaDevices.getUserMedia({audio:!0,video:!1})];case 1:return[2,e.sent()]}})})}var BrowserFftFeatureExtractor=function(){function e(e){if(null==e)throw new Error("Required configuration object is missing for BrowserFftFeatureExtractor constructor");if(null==e.spectrogramCallback)throw new Error("spectrogramCallback cannot be null or undefined");if(!(e.numFramesPerSpectrogram>0))throw new Error("Invalid value in numFramesPerSpectrogram: "+e.numFramesPerSpectrogram);if(e.suppressionTimeMillis<0)throw new Error("Expected suppressionTimeMillis to be >= 0, but got "+e.suppressionTimeMillis);if(this.suppressionTimeMillis=e.suppressionTimeMillis,this.spectrogramCallback=e.spectrogramCallback,this.numFrames=e.numFramesPerSpectrogram,this.sampleRateHz=e.sampleRateHz||44100,this.fftSize=e.fftSize||1024,this.frameDurationMillis=this.fftSize/this.sampleRateHz*1e3,this.columnTruncateLength=e.columnTruncateLength||this.fftSize,this.overlapFactor=e.overlapFactor,util.assert(this.overlapFactor>=0&&this.overlapFactor<1,"Expected overlapFactor to be >= 0 and < 1, but got "+this.overlapFactor),this.columnTruncateLength>this.fftSize)throw new Error("columnTruncateLength "+this.columnTruncateLength+" exceeds fftSize ("+this.fftSize+").");this.audioContextConstructor=getAudioContextConstructor()}return e.prototype.start=function(){return __awaiter(this,void 0,void 0,function(){var e,t,r;return __generator(this,function(a){switch(a.label){case 0:if(null!=this.frameIntervalTask)throw new Error("Cannot start already-started BrowserFftFeatureExtractor");return e=this,[4,getAudioMediaStream()];case 1:return e.stream=a.sent(),this.audioContext=new this.audioContextConstructor,this.audioContext.sampleRate!==this.sampleRateHz&&console.warn("Mismatch in sampling rate: Expected: "+this.sampleRateHz+"; Actual: "+this.audioContext.sampleRate),t=this.audioContext.createMediaStreamSource(this.stream),this.analyser=this.audioContext.createAnalyser(),this.analyser.fftSize=2*this.fftSize,this.analyser.smoothingTimeConstant=0,t.connect(this.analyser),this.freqDataQueue=[],this.freqData=new Float32Array(this.fftSize),r=Math.max(1,Math.round(this.numFrames*(1-this.overlapFactor))),this.tracker=new Tracker(r,Math.round(this.suppressionTimeMillis/this.frameDurationMillis)),this.frameIntervalTask=setInterval(this.onAudioFrame.bind(this),this.fftSize/this.sampleRateHz*1e3),[2]}})})},e.prototype.onAudioFrame=function(){return __awaiter(this,void 0,void 0,function(){var e,t;return __generator(this,function(r){switch(r.label){case 0:return this.analyser.getFloatFrequencyData(this.freqData),this.freqData[0]===-1/0?[2]:(this.freqDataQueue.push(this.freqData.slice(0,this.columnTruncateLength)),this.freqDataQueue.length>this.numFrames&&this.freqDataQueue.shift(),this.tracker.tick()?(e=flattenQueue(this.freqDataQueue),t=getInputTensorFromFrequencyData(e,[1,this.numFrames,this.columnTruncateLength,1]),[4,this.spectrogramCallback(t)]):[3,2]);case 1:r.sent()&&this.tracker.suppress(),t.dispose(),r.label=2;case 2:return[2]}})})},e.prototype.stop=function(){return __awaiter(this,void 0,void 0,function(){return __generator(this,function(e){if(null==this.frameIntervalTask)throw new Error("Cannot stop because there is no ongoing streaming activity.");return clearInterval(this.frameIntervalTask),this.frameIntervalTask=null,this.analyser.disconnect(),this.audioContext.close(),null!=this.stream&&this.stream.getTracks().length>0&&this.stream.getTracks()[0].stop(),[2]})})},e.prototype.setConfig=function(e){throw new Error("setConfig() is not implemented for BrowserFftFeatureExtractor.")},e.prototype.getFeatures=function(){throw new Error("getFeatures() is not implemented for BrowserFftFeatureExtractor. Use the spectrogramCallback field of the constructor config instead.")},e}();function flattenQueue(e){var t=e[0].length,r=new Float32Array(e.length*t);return e.forEach(function(e,a){return r.set(e,a*t)}),r}function getInputTensorFromFrequencyData(e,t){var r=new Float32Array(util.sizeFromShape(t));return r.set(e,r.length-e.length),tensor(r,t)}var Tracker=function(){function e(e,t){this.period=e,this.suppressionTime=null==t?0:t,this.counter=0,util.assert(this.period>0,"Expected period to be positive, but got "+this.period)}return e.prototype.tick=function(){return this.counter++,this.counter%this.period==0&&(null==this.suppressionOnset||this.counter-this.suppressionOnset>this.suppressionTime)},e.prototype.suppress=function(){this.suppressionOnset=this.counter},e}();function concatenateArrayBuffers(e){var t=0;e.forEach(function(e){t+=e.byteLength});var r=new Uint8Array(t),a=0;return e.forEach(function(e){r.set(new Uint8Array(e),a),a+=e.byteLength}),r.buffer}function string2ArrayBuffer(e){if(null==e)throw new Error("Received null or undefind string");for(var t=unescape(encodeURIComponent(e)),r=new Uint8Array(t.length),a=0;a<t.length;++a)r[a]=t.charCodeAt(a);return r.buffer}function arrayBuffer2String(e){if(null==e)throw new Error("Received null or undefind buffer");var t=new Uint8Array(e);return decodeURIComponent(escape(String.fromCharCode.apply(String,__spread(t))))}function getUID(){function e(){return Math.floor(65536*(1+Math.random())).toString(16).substring(1)}return e()+e()+"-"+e()+"-"+e()+"-"+e()+"-"+e()+e()+e()}function balancedTrainValSplit(e,t,r){return util.assert(r>0&&r<1,"validationSplit is expected to be >0 and <1, but got "+r),tidy(function(){for(var a=t.argMax(-1).dataSync(),n=[],s=0;s<a.length;++s){var i=a[s];null==n[i]&&(n[i]=[]),n[i].push(s)}var o=n.length,l=[],u=[];n.map(function(e){return util.shuffle(e)});for(s=0;s<o;++s)for(var c=n[s],h=Math.round(c.length*(1-r)),d=0;d<c.length;++d)d<h?l.push(c[d]):u.push(c[d]);return{trainXs:gather(e,l),trainYs:gather(t,l),valXs:gather(e,u),valYs:gather(t,u)}})}function balancedTrainValSplitNumArrays(e,t,r){var a,n,s,i,o,l,u,c;util.assert(r>0&&r<1,"validationSplit is expected to be >0 and <1, but got "+r);for(var h=!Array.isArray(e[0]),d=t,p=[],f=0;f<d.length;++f){var m=d[f];null==p[m]&&(p[m]=[]),p[m].push(f)}var g=p.length,v=[],y=[];p.map(function(e){return util.shuffle(e)});for(f=0;f<g;++f)for(var b=p[f],w=Math.round(b.length*(1-r)),_=0;_<b.length;++_)_<w?v.push(b[_]):y.push(b[_]);if(h){var S=[],E=[],x=[],T=[];try{for(var A=__values(v),I=A.next();!I.done;I=A.next()){var F=I.value;S.push(e[F]),E.push(t[F])}}catch(e){a={error:e}}finally{try{I&&!I.done&&(n=A.return)&&n.call(A)}finally{if(a)throw a.error}}try{for(var D=__values(y),M=D.next();!M.done;M=D.next()){F=M.value;x.push(e[F]),T.push(t[F])}}catch(e){s={error:e}}finally{try{M&&!M.done&&(i=D.return)&&i.call(D)}finally{if(s)throw s.error}}return{trainXs:S,trainYs:E,valXs:x,valYs:T}}S=[],E=[],x=[],T=[];try{for(var z=__values(v),O=z.next();!O.done;O=z.next()){F=O.value;S.push(e[F]),E.push(t[F])}}catch(e){o={error:e}}finally{try{O&&!O.done&&(l=z.return)&&l.call(z)}finally{if(o)throw o.error}}try{for(var L=__values(y),R=L.next();!R.done;R=L.next()){F=R.value;x.push(e[F]),T.push(t[F])}}catch(e){u={error:e}}finally{try{R&&!R.done&&(c=L.return)&&c.call(L)}finally{if(u)throw u.error}}return{trainXs:S,trainYs:E,valXs:x,valYs:T}}var DATASET_SERIALIZATION_DESCRIPTOR="TFJSSCDS",DATASET_SERIALIZATION_VERSION=1,BACKGROUND_NOISE_TAG="_background_noise_",Dataset=function(){function e(e){if(this.examples={},this.label2Ids={},null!=e)for(var t=arrayBuffer2SerializedExamples(e),r=0,a=0;a<t.manifest.length;++a){var n=t.manifest[a],s=n.spectrogramNumFrames*n.spectrogramFrameSize;null!=n.rawAudioNumSamples&&(s+=n.rawAudioNumSamples),s*=4,this.addExample(deserializeExample({spec:n,data:t.data.slice(r,r+s)})),r+=s}}return e.prototype.addExample=function(e){util.assert(null!=e,"Got null or undefined example"),util.assert(null!=e.label&&e.label.length>0,"Expected label to be a non-empty string, but got "+JSON.stringify(e.label));var t=getUID();return this.examples[t]=e,e.label in this.label2Ids||(this.label2Ids[e.label]=[]),this.label2Ids[e.label].push(t),t},e.prototype.merge=function(e){var t,r,a,n;util.assert(e!==this,"Cannot merge a dataset into itself");var s=e.getVocabulary();try{for(var i=__values(s),o=i.next();!o.done;o=i.next()){var l=o.value,u=e.getExamples(l);try{for(var c=__values(u),h=c.next();!h.done;h=c.next()){var d=h.value;this.addExample(d.example)}}catch(e){a={error:e}}finally{try{h&&!h.done&&(n=c.return)&&n.call(c)}finally{if(a)throw a.error}}}}catch(e){t={error:e}}finally{try{o&&!o.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}},e.prototype.getExampleCounts=function(){var e={};for(var t in this.examples){var r=this.examples[t];r.label in e||(e[r.label]=0),e[r.label]++}return e},e.prototype.getExamples=function(e){var t=this;util.assert(null!=e,"Expected label to be a string, but got "+JSON.stringify(e)),util.assert(e in this.label2Ids,'No example of label "'+e+'" exists in dataset');var r=[];return this.label2Ids[e].forEach(function(e){r.push({uid:e,example:t.examples[e]})}),r},e.prototype.getData=function(e,t){var r=this;util.assert(this.size()>0,"Cannot get spectrograms as tensors because the dataset is empty");var a=this.getVocabulary();null!=e?util.assert(-1!==a.indexOf(e),"Label "+e+" is not in the vocabulary ("+JSON.stringify(a)+")"):util.assert(a.length>1,"One-hot encoding of labels requires the vocabulary to have at least two words, but it has only "+a.length+" word."),null==t&&(t={});var n,s,i=this.getSortedUniqueNumFrames();1===i.length?(n=null==t.numFrames?i[0]:t.numFrames,s=null==t.hopFrames?1:t.hopFrames):(n=t.numFrames,util.assert(null!=n&&Number.isInteger(n)&&n>0,"There are "+i.length+" unique lengths among the "+this.size()+" examples of this Dataset, hence numFrames is required. But it is not provided."),util.assert(n<=i[0],"numFrames ("+n+") exceeds the minimum numFrames ("+i[0]+") among the examples of the Dataset."),s=t.hopFrames,util.assert(null!=s&&Number.isInteger(s)&&s>0,"There are "+i.length+" unique lengths among the "+this.size()+" examples of this Dataset, hence hopFrames is required. But it is not provided."));var o=null==t.normalize||t.normalize;return tidy(function(){for(var i,l,u,c=[],h=[],d=[],p=[],f=0;f<a.length;++f){var m=a[f];if(null==e||m===e){var g=r.label2Ids[m],v=function(a){var i,l,g=r.examples[a].spectrogram,v=g.frameSize;null==u?u=v:util.assert(v===u,"Mismatch in frameSize  ("+v+" vs "+u+")");var y=g.data.length/v,b=null;m!==BACKGROUND_NOISE_TAG&&(b=null==g.keyFrameIndex?getMaxIntensityFrameIndex(g).dataSync()[0]:g.keyFrameIndex);var w=tensor3d(g.data,[y,v,1]),_=getValidWindows(y,b,n,s),S=function(r){var a=tidy(function(){var e=w.slice([r[0],0,0],[r[1]-r[0],-1,-1]);return o?normalize(e):e});t.getDataset?(h.push(a.dataSync()),d.push(f)):c.push(a),null==e&&p.push(f)};try{for(var E=__values(_),x=E.next();!x.done;x=E.next()){S(x.value)}}catch(e){i={error:e}}finally{try{x&&!x.done&&(l=E.return)&&l.call(E)}finally{if(i)throw i.error}}dispose(w)};try{for(var y=__values(g),b=y.next();!b.done;b=y.next()){v(b.value)}}catch(e){i={error:e}}finally{try{b&&!b.done&&(l=y.return)&&l.call(y)}finally{if(i)throw i.error}}}}var w=null==t.shuffle||t.shuffle;if(t.getDataset){var _=null==t.datasetBatchSize?32:t.datasetBatchSize,S=null==t.datasetValidationSplit?.15:t.datasetValidationSplit;util.assert(S>0&&S<1,"Invalid dataset validation split: "+S);var E=h.map(function(e,t){return[e,d[t]]});util.shuffle(E),h=E.map(function(e){return e[0]}),d=E.map(function(e){return e[1]});var x=balancedTrainValSplitNumArrays(h,d,S),T=x.trainXs,A=x.trainYs,I=x.valXs,F=x.valYs,D=data.array(T).map(function(e){return tensor3d(e,[n,u,1])}),M=data.array(A).map(function(e){return oneHot([e],a.length).squeeze([0])}),z=data.zip([D,M]);w&&(z=z.shuffle(h.length)),z=z.batch(_).prefetch(4);var O=data.array(I).map(function(e){return tensor3d(e,[n,u,1])}),L=data.array(F).map(function(e){return oneHot([e],a.length).squeeze([0])}),R=data.zip([O,L]);return[z,R=R.batch(_).prefetch(4)]}if(w){var N=[];c.forEach(function(e,t){N.push({x:e,y:p[t]})}),util.shuffle(N),c=N.map(function(e){return e.x}),p=N.map(function(e){return e.y})}var C=null==e?oneHot(tensor1d(p,"int32"),a.length).asType("float32"):void 0;return{xs:stack(c),ys:C}})},e.prototype.getSortedUniqueNumFrames=function(){for(var e,t,r=new Set,a=this.getVocabulary(),n=0;n<a.length;++n){var s=a[n],i=this.label2Ids[s];try{for(var o=__values(i),l=o.next();!l.done;l=o.next()){var u=l.value,c=this.examples[u].spectrogram,h=c.data.length/c.frameSize;r.add(h)}}catch(t){e={error:t}}finally{try{l&&!l.done&&(t=o.return)&&t.call(o)}finally{if(e)throw e.error}}}var d=__spread(r);return d.sort(),d},e.prototype.removeExample=function(e){if(!(e in this.examples))throw new Error("Nonexistent example UID: "+e);var t=this.examples[e].label;delete this.examples[e];var r=this.label2Ids[t].indexOf(e);this.label2Ids[t].splice(r,1),0===this.label2Ids[t].length&&delete this.label2Ids[t]},e.prototype.setExampleKeyFrameIndex=function(e,t){if(!(e in this.examples))throw new Error("Nonexistent example UID: "+e);var r=this.examples[e].spectrogram,a=r.data.length/r.frameSize;util.assert(t>=0&&t<a&&Number.isInteger(t),"Invalid keyFrameIndex: "+t+". Must be >= 0, < "+a+", and an integer."),r.keyFrameIndex=t},e.prototype.size=function(){return Object.keys(this.examples).length},e.prototype.durationMillis=function(){var e=0;for(var t in this.examples){var r=this.examples[t].spectrogram,a=23.22|r.frameDurationMillis;e+=r.data.length/r.frameSize*a}return e},e.prototype.empty=function(){return 0===this.size()},e.prototype.clear=function(){this.examples={}},e.prototype.getVocabulary=function(){var e=new Set;for(var t in this.examples){var r=this.examples[t];e.add(r.label)}var a=__spread(e);return a.sort(),a},e.prototype.serialize=function(){var e,t,r,a,n=this.getVocabulary();util.assert(!this.empty(),"Cannot serialize empty Dataset");var s=[],i=[];try{for(var o=__values(n),l=o.next();!l.done;l=o.next()){var u=l.value,c=this.label2Ids[u];try{for(var h=__values(c),d=h.next();!d.done;d=h.next()){var p=d.value,f=serializeExample(this.examples[p]);s.push(f.spec),i.push(f.data)}}catch(e){r={error:e}}finally{try{d&&!d.done&&(a=h.return)&&a.call(h)}finally{if(r)throw r.error}}}}catch(t){e={error:t}}finally{try{l&&!l.done&&(t=o.return)&&t.call(o)}finally{if(e)throw e.error}}return serializedExamples2ArrayBuffer({manifest:s,data:concatenateArrayBuffers(i)})},e}();function serializeExample(e){var t=null!=e.rawAudio,r={label:e.label,spectrogramNumFrames:e.spectrogram.data.length/e.spectrogram.frameSize,spectrogramFrameSize:e.spectrogram.frameSize};null!=e.spectrogram.keyFrameIndex&&(r.spectrogramKeyFrameIndex=e.spectrogram.keyFrameIndex);var a=e.spectrogram.data.buffer.slice(0);return t&&(r.rawAudioNumSamples=e.rawAudio.data.length,r.rawAudioSampleRateHz=e.rawAudio.sampleRateHz,a=concatenateArrayBuffers([a,e.rawAudio.data.buffer])),{spec:r,data:a}}function deserializeExample(e){var t={frameSize:e.spec.spectrogramFrameSize,data:new Float32Array(e.data.slice(0,4*e.spec.spectrogramFrameSize*e.spec.spectrogramNumFrames))};null!=e.spec.spectrogramKeyFrameIndex&&(t.keyFrameIndex=e.spec.spectrogramKeyFrameIndex);var r={label:e.spec.label,spectrogram:t};return null!=e.spec.rawAudioNumSamples&&(r.rawAudio={sampleRateHz:e.spec.rawAudioSampleRateHz,data:new Float32Array(e.data.slice(4*e.spec.spectrogramFrameSize*e.spec.spectrogramNumFrames))}),r}function serializedExamples2ArrayBuffer(e){var t=string2ArrayBuffer(JSON.stringify(e.manifest)),r=string2ArrayBuffer(DATASET_SERIALIZATION_DESCRIPTOR),a=new Uint32Array([DATASET_SERIALIZATION_VERSION]),n=new Uint32Array([t.byteLength]);return concatenateArrayBuffers([concatenateArrayBuffers([r,a.buffer,n.buffer]),t,e.data])}function arrayBuffer2SerializedExamples(e){util.assert(null!=e,"Received null or undefined buffer");var t=0,r=arrayBuffer2String(e.slice(t,DATASET_SERIALIZATION_DESCRIPTOR.length));util.assert(r===DATASET_SERIALIZATION_DESCRIPTOR,"Deserialization error: Invalid descriptor"),t+=DATASET_SERIALIZATION_DESCRIPTOR.length,t+=4;var a=new Uint32Array(e,t,1),n=t+=4;t=n+a[0];var s=arrayBuffer2String(e.slice(n,t));return{manifest:JSON.parse(s),data:e.slice(t)}}function getValidWindows(e,t,r,a){if(util.assert(Number.isInteger(e)&&e>0,"snippetLength must be a positive integer, but got "+e),null!=t&&util.assert(Number.isInteger(t)&&t>=0,"focusIndex must be a non-negative integer, but got "+t),util.assert(Number.isInteger(r)&&r>0,"windowLength must be a positive integer, but got "+r),util.assert(Number.isInteger(a)&&a>0,"windowHop must be a positive integer, but got "+a),util.assert(r<=e,"windowLength ("+r+") exceeds snippetLength ("+e+")"),util.assert(t<e,"focusIndex ("+t+") equals or exceeds snippetLength ("+e+")"),r===e)return[[0,e]];var n=[];if(null==t){for(var s=0;s+r<=e;)n.push([s,s+r]),s+=a;return n}var i=t-Math.floor(r/2);for(i<0?i=0:i+r>e&&(i=e-r);!(i-a<0||t>=i-a+r);)i-=a;for(;i+r<=e&&!(t<i);)n.push([i,i+r]),i+=a;return n}function spectrogram2IntensityCurve(e){return tidy(function(){var t=e.data.length/e.frameSize;return tensor2d(e.data,[t,e.frameSize]).mean(-1)})}function getMaxIntensityFrameIndex(e){return tidy(function(){return spectrogram2IntensityCurve(e).argMax()})}var version="0.2.3",UNKNOWN_TAG="_unknown_",SAVED_MODEL_METADATA_KEY="tfjs-speech-commands-saved-model-metadata",SAVE_PATH_PREFIX="indexeddb://tfjs-speech-commands-model/",streaming=!1,localStorageWrapper={localStorage:"undefined"==typeof window?null:window.localStorage};function getMajorAndMinorVersion(e){return e.split(".").slice(0,2).join(".")}var DEFAULT_WINDOW_HOP_RATIO=.25,BrowserFftSpeechCommandRecognizer=function(){function e(t,r,a){this.MODEL_URL_PREFIX="https://storage.googleapis.com/tfjs-models/tfjs/speech-commands/v"+getMajorAndMinorVersion(version)+"/browser_fft",this.SAMPLE_RATE_HZ=44100,this.FFT_SIZE=1024,this.DEFAULT_SUPPRESSION_TIME_MILLIS=0,this.transferRecognizers={},util.assert(null==r&&null==a||null!=r&&null!=a,"modelURL and metadataURL must be both provided or both not provided."),null==r?(null==t?t=e.DEFAULT_VOCABULARY_NAME:util.assert(-1!==e.VALID_VOCABULARY_NAMES.indexOf(t),"Invalid vocabulary name: '"+t+"'"),this.vocabulary=t,this.modelURL=this.MODEL_URL_PREFIX+"/"+this.vocabulary+"/model.json",this.metadataURL=this.MODEL_URL_PREFIX+"/"+this.vocabulary+"/metadata.json"):(util.assert(null==t,"vocabulary name must be null or undefined when modelURL is provided"),this.modelURL=r,this.metadataURL=a),this.parameters={sampleRateHz:this.SAMPLE_RATE_HZ,fftSize:this.FFT_SIZE}}return e.prototype.listen=function(e,t){return __awaiter(this,void 0,void 0,function(){var r,a,n,s,i,o=this;return __generator(this,function(l){switch(l.label){case 0:if(streaming)throw new Error("Cannot start streaming again when streaming is ongoing.");return[4,this.ensureModelLoaded()];case 1:if(l.sent(),null==t&&(t={}),r=null==t.probabilityThreshold?0:t.probabilityThreshold,t.includeEmbedding&&(r=0),util.assert(r>=0&&r<=1,"Invalid probabilityThreshold value: "+r),a=null!=t.invokeCallbackOnNoiseAndUnknown&&t.invokeCallbackOnNoiseAndUnknown,t.includeEmbedding&&(a=!0),t.suppressionTimeMillis<0)throw new Error("suppressionTimeMillis is expected to be >= 0, but got "+t.suppressionTimeMillis);return n=null==t.overlapFactor?.5:t.overlapFactor,util.assert(n>=0&&n<1,"Expected overlapFactor to be >= 0 and < 1, but got "+n),s=function(n){return __awaiter(o,void 0,void 0,function(){var s,i,o,l,u,c,h,d,p,f,m;return __generator(this,function(g){switch(g.label){case 0:return i=normalize(n),t.includeEmbedding?[4,this.ensureModelWithEmbeddingOutputCreated()]:[3,2];case 1:return g.sent(),s=__read(this.modelWithEmbeddingOutput.predict(i),2),o=s[0],l=s[1],[3,3];case 2:o=this.model.predict(i),g.label=3;case 3:return[4,o.data()];case 4:return u=g.sent(),[4,(c=o.argMax(-1)).data()];case 5:return h=g.sent()[0],d=Math.max.apply(Math,__spread(u)),dispose([o,c,i]),d<r?[2,!1]:[3,6];case 6:return p=void 0,t.includeSpectrogram?(f={},[4,n.data()]):[3,8];case 7:f.data=g.sent(),f.frameSize=this.nonBatchInputShape[1],p=f,g.label=8;case 8:return m=!0,a||this.words[h]!==BACKGROUND_NOISE_TAG&&this.words[h]!==UNKNOWN_TAG||(m=!1),m&&e({scores:u,spectrogram:p,embedding:l}),[2,m]}})})},i=null==t.suppressionTimeMillis?this.DEFAULT_SUPPRESSION_TIME_MILLIS:t.suppressionTimeMillis,this.audioDataExtractor=new BrowserFftFeatureExtractor({sampleRateHz:this.parameters.sampleRateHz,numFramesPerSpectrogram:this.nonBatchInputShape[0],columnTruncateLength:this.nonBatchInputShape[1],suppressionTimeMillis:i,spectrogramCallback:s,overlapFactor:n}),[4,this.audioDataExtractor.start()];case 2:return l.sent(),streaming=!0,[2]}})})},e.prototype.ensureModelLoaded=function(){return __awaiter(this,void 0,void 0,function(){var e,t,r,a,n=this;return __generator(this,function(s){switch(s.label){case 0:return null!=this.model?[2]:[4,this.ensureMetadataLoaded()];case 1:return s.sent(),[4,loadModel(this.modelURL)];case 2:if(1!==(e=s.sent()).inputs.length)throw new Error("Expected model to have 1 input, but got a model with "+e.inputs.length+" inputs");if(4!==e.inputs[0].shape.length)throw new Error("Expected model to have an input shape of rank 4, but got an input shape of rank "+e.inputs[0].shape.length);if(1!==e.inputs[0].shape[3])throw new Error("Expected model to have an input shape with 1 as the last dimension, but got input shape"+JSON.stringify(e.inputs[0].shape[3])+"}");if(2!==(t=e.outputShape).length)throw new Error("Expected loaded model to have an output shape of rank 2,but received shape "+JSON.stringify(t));if(t[1]!==this.words.length)throw new Error("Mismatch between the last dimension of model's output shape ("+t[1]+") and number of words ("+this.words.length+").");return this.model=e,this.freezeModel(),this.nonBatchInputShape=e.inputs[0].shape.slice(1),this.elementsPerExample=1,e.inputs[0].shape.slice(1).forEach(function(e){return n.elementsPerExample*=e}),this.warmUpModel(),r=this.parameters.fftSize/this.parameters.sampleRateHz*1e3,a=e.inputs[0].shape[1],this.parameters.spectrogramDurationMillis=a*r,[2]}})})},e.prototype.ensureModelWithEmbeddingOutputCreated=function(){return __awaiter(this,void 0,void 0,function(){var e,t;return __generator(this,function(r){switch(r.label){case 0:return null!=this.modelWithEmbeddingOutput?[2]:[4,this.ensureModelLoaded()];case 1:for(r.sent(),t=this.model.layers.length-2;t>=0;--t)if("Dense"===this.model.layers[t].getClassName()){e=this.model.layers[t];break}if(null==e)throw new Error("Failed to find second last dense layer in the original model.");return this.modelWithEmbeddingOutput=model({inputs:this.model.inputs,outputs:[this.model.outputs[0],e.output]}),[2]}})})},e.prototype.warmUpModel=function(){var e=this;tidy(function(){for(var t=zeros([1].concat(e.nonBatchInputShape)),r=0;r<3;++r)e.model.predict(t)})},e.prototype.ensureMetadataLoaded=function(){return __awaiter(this,void 0,void 0,function(){var e;return __generator(this,function(t){switch(t.label){case 0:return null!=this.words?[2]:[4,loadMetadataJson(this.metadataURL)];case 1:return e=t.sent(),this.words=e.words,[2]}})})},e.prototype.stopListening=function(){return __awaiter(this,void 0,void 0,function(){return __generator(this,function(e){switch(e.label){case 0:if(!streaming)throw new Error("Cannot stop streaming when streaming is not ongoing.");return[4,this.audioDataExtractor.stop()];case 1:return e.sent(),streaming=!1,[2]}})})},e.prototype.isListening=function(){return streaming},e.prototype.wordLabels=function(){return this.words},e.prototype.params=function(){return this.parameters},e.prototype.modelInputShape=function(){if(null==this.model)throw new Error("Model has not been loaded yet. Load model by calling ensureModelLoaded(), recognize(), or listen().");return this.model.inputs[0].shape},e.prototype.recognize=function(e,t){return __awaiter(this,void 0,void 0,function(){var r,a,n,s,i,o,l,u,c,h,d,p,f;return __generator(this,function(m){switch(m.label){case 0:return null==t&&(t={}),[4,this.ensureModelLoaded()];case 1:return m.sent(),null!=e?[3,3]:[4,this.recognizeOnline()];case 2:r=m.sent(),e=r.data,m.label=3;case 3:if(e instanceof Tensor)this.checkInputTensorShape(e),n=e,a=e.shape[0];else{if((e=e).length%this.elementsPerExample)throw new Error("The length of the input Float32Array "+e.length+" is not divisible by the number of tensor elements per per example expected by the model "+this.elementsPerExample+".");a=e.length/this.elementsPerExample,n=tensor4d(e,[a].concat(this.nonBatchInputShape))}return i={scores:null},t.includeEmbedding?[4,this.ensureModelWithEmbeddingOutputCreated()]:[3,5];case 4:return m.sent(),o=this.modelWithEmbeddingOutput.predict(n),s=o[0],i.embedding=o[1],[3,6];case 5:s=this.model.predict(n),m.label=6;case 6:return 1!==a?[3,8]:(l=i,[4,s.data()]);case 7:return l.scores=m.sent(),[3,10];case 8:return u=unstack(s),c=u.map(function(e){return e.data()}),h=i,[4,Promise.all(c)];case 9:h.scores=m.sent(),dispose(u),m.label=10;case 10:return t.includeSpectrogram?(d=i,p={},e instanceof Tensor?[4,e.data()]:[3,12]):[3,14];case 11:return f=m.sent(),[3,13];case 12:f=e,m.label=13;case 13:d.spectrogram=(p.data=f,p.frameSize=this.nonBatchInputShape[1],p),m.label=14;case 14:return[2,i]}})})},e.prototype.recognizeOnline=function(){return __awaiter(this,void 0,void 0,function(){var e=this;return __generator(this,function(t){return[2,new Promise(function(t,r){e.audioDataExtractor=new BrowserFftFeatureExtractor({sampleRateHz:e.parameters.sampleRateHz,numFramesPerSpectrogram:e.nonBatchInputShape[0],columnTruncateLength:e.nonBatchInputShape[1],suppressionTimeMillis:0,spectrogramCallback:function(r){return __awaiter(e,void 0,void 0,function(){var e,a,n;return __generator(this,function(s){switch(s.label){case 0:return e=normalize(r),[4,this.audioDataExtractor.stop()];case 1:return s.sent(),a=t,n={},[4,e.data()];case 2:return a.apply(void 0,[(n.data=s.sent(),n.frameSize=this.nonBatchInputShape[1],n)]),e.dispose(),[2,!1]}})})},overlapFactor:0}),e.audioDataExtractor.start()})]})})},e.prototype.createTransfer=function(e){if(null==this.model)throw new Error("Model has not been loaded yet. Load model by calling ensureModelLoaded(), recognizer(), or listen().");util.assert(null!=e&&"string"==typeof e&&e.length>1,"Expected the name for a transfer-learning recognized to be a non-empty string, but got "+JSON.stringify(e)),util.assert(null==this.transferRecognizers[e],"There is already a transfer-learning model named '"+e+"'");var t=new TransferBrowserFftSpeechCommandRecognizer(e,this.parameters,this.model);return this.transferRecognizers[e]=t,t},e.prototype.freezeModel=function(){var e,t;try{for(var r=__values(this.model.layers),a=r.next();!a.done;a=r.next()){a.value.trainable=!1}}catch(t){e={error:t}}finally{try{a&&!a.done&&(t=r.return)&&t.call(r)}finally{if(e)throw e.error}}},e.prototype.checkInputTensorShape=function(e){var t=this.model.inputs[0].shape.length;if(e.shape.length!==t)throw new Error("Expected input Tensor to have rank "+t+", but got rank "+e.shape.length+" that differs ");var r=e.shape.slice(1),a=this.model.inputs[0].shape.slice(1);if(!util.arraysEqual(r,a))throw new Error("Expected input to have shape [null,"+a+"], but got shape [null,"+r+"]")},e.VALID_VOCABULARY_NAMES=["18w","directional4w"],e.DEFAULT_VOCABULARY_NAME="18w",e}(),TransferBrowserFftSpeechCommandRecognizer=function(e){function t(t,r,a){var n=e.call(this)||this;return n.name=t,n.parameters=r,n.baseModel=a,util.assert(null!=t&&"string"==typeof t&&t.length>0,"The name of a transfer model must be a non-empty string, but got "+JSON.stringify(t)),n.nonBatchInputShape=n.baseModel.inputs[0].shape.slice(1),n.words=null,n.dataset=new Dataset,n}return __extends(t,e),t.prototype.collectExample=function(e,t){return __awaiter(this,void 0,void 0,function(){var r,a,n=this;return __generator(this,function(s){if(util.assert(!streaming,"Cannot start collection of transfer-learning example because a streaming recognition or transfer-learning example collection is ongoing"),util.assert(null!=e&&"string"==typeof e&&e.length>0,"Must provide a non-empty string when collecting transfer-learning example"),null==t&&(t={}),null!=t.durationMultiplier&&null!=t.durationSec)throw new Error("durationMultiplier and durationSec are mutually exclusive, but are both specified.");return null!=t.durationSec?(util.assert(t.durationSec>0,"Expected durationSec to be > 0, but got "+t.durationSec),a=this.parameters.fftSize/this.parameters.sampleRateHz,r=Math.ceil(t.durationSec/a)):null!=t.durationMultiplier?(util.assert(t.durationMultiplier>=1,"Expected duration multiplier to be >= 1, but got "+t.durationMultiplier),r=Math.round(this.nonBatchInputShape[0]*t.durationMultiplier)):r=this.nonBatchInputShape[0],streaming=!0,[2,new Promise(function(t){n.audioDataExtractor=new BrowserFftFeatureExtractor({sampleRateHz:n.parameters.sampleRateHz,numFramesPerSpectrogram:r,columnTruncateLength:n.nonBatchInputShape[1],suppressionTimeMillis:0,spectrogramCallback:function(r){return __awaiter(n,void 0,void 0,function(){var a,n,s,i,o,l,u;return __generator(this,function(c){switch(c.label){case 0:return a=normalize(r),s=(n=this.dataset).addExample,i={label:e},o={},[4,a.data()];case 1:return s.apply(n,[(i.spectrogram=(o.data=c.sent(),o.frameSize=this.nonBatchInputShape[1],o),i)]),a.dispose(),[4,this.audioDataExtractor.stop()];case 2:return c.sent(),streaming=!1,this.collateTransferWords(),l=t,u={},[4,r.data()];case 3:return l.apply(void 0,[(u.data=c.sent(),u.frameSize=this.nonBatchInputShape[1],u)]),[2,!1]}})})},overlapFactor:0}),n.audioDataExtractor.start()})]})})},t.prototype.clearExamples=function(){util.assert(null!=this.words&&this.words.length>0&&!this.dataset.empty(),"No transfer learning examples exist for model name "+this.name),this.dataset.clear(),this.words=null},t.prototype.countExamples=function(){if(this.dataset.empty())throw new Error("No examples have been collected for transfer-learning model named '"+this.name+"' yet.");return this.dataset.getExampleCounts()},t.prototype.getExamples=function(e){return this.dataset.getExamples(e)},t.prototype.setExampleKeyFrameIndex=function(e,t){this.dataset.setExampleKeyFrameIndex(e,t)},t.prototype.removeExample=function(e){this.dataset.removeExample(e),this.collateTransferWords()},t.prototype.isDatasetEmpty=function(){return this.dataset.empty()},t.prototype.loadExamples=function(e,t){var r,a,n,s;void 0===t&&(t=!1);var i=new Dataset(e);t&&this.clearExamples();var o=i.getVocabulary();try{for(var l=__values(o),u=l.next();!u.done;u=l.next()){var c=u.value,h=i.getExamples(c);try{for(var d=__values(h),p=d.next();!p.done;p=d.next()){var f=p.value;this.dataset.addExample(f.example)}}catch(e){n={error:e}}finally{try{p&&!p.done&&(s=d.return)&&s.call(d)}finally{if(n)throw n.error}}}}catch(e){r={error:e}}finally{try{u&&!u.done&&(a=l.return)&&a.call(l)}finally{if(r)throw r.error}}this.collateTransferWords()},t.prototype.serializeExamples=function(){return this.dataset.serialize()},t.prototype.collateTransferWords=function(){this.words=this.dataset.getVocabulary()},t.prototype.collectTransferDataAsTensors=function(e){var t=this.nonBatchInputShape[0];e=e||DEFAULT_WINDOW_HOP_RATIO;var r=Math.round(e*t),a=this.dataset.getData(null,{numFrames:t,hopFrames:r});return{xs:a.xs,ys:a.ys}},t.prototype.collectTransferDataAsTfDataset=function(e,t,r){void 0===t&&(t=.15),void 0===r&&(r=32);var a=this.nonBatchInputShape[0];e=e||DEFAULT_WINDOW_HOP_RATIO;var n=Math.round(e*a);return this.dataset.getData(null,{numFrames:a,hopFrames:n,getDataset:!0,datasetBatchSize:r,datasetValidationSplit:t})},t.prototype.train=function(e){return __awaiter(this,void 0,void 0,function(){var t;return __generator(this,function(r){switch(r.label){case 0:return util.assert(null!=this.words&&this.words.length>0,"Cannot train transfer-learning model '"+this.name+"' because no transfer learning example has been collected."),util.assert(this.words.length>1,"Cannot train transfer-learning model '"+this.name+"' because only 1 word label ('"+JSON.stringify(this.words)+"') has been collected for transfer learning. Requires at least 2."),null!=e.fineTuningEpochs&&util.assert(e.fineTuningEpochs>=0&&Number.isInteger(e.fineTuningEpochs),"If specified, fineTuningEpochs must be a non-negative integer, but received "+e.fineTuningEpochs),null==e&&(e={}),null==this.model&&this.createTransferModelFromBaseModel(),this.secondLastBaseDenseLayer.trainable=!1,this.model.compile({loss:"categoricalCrossentropy",optimizer:e.optimizer||"sgd",metrics:["acc"]}),t=null==e.fitDatasetDurationMillisThreshold?6e4:e.fitDatasetDurationMillisThreshold,console.log("Detected large dataset: total duration = "+this.dataset.durationMillis()+" ms > "+t+" ms. Training transfer model using fitDataset() instead of fit()"),this.dataset.durationMillis()>t?[4,this.trainOnDataset(e)]:[3,2];case 1:return[2,r.sent()];case 2:return[4,this.trainOnTensors(e)];case 3:return[2,r.sent()]}})})},t.prototype.trainOnDataset=function(e){return __awaiter(this,void 0,void 0,function(){var t,r,a,n,s,i,o,l,u;return __generator(this,function(c){switch(c.label){case 0:return util.assert(e.epochs>0,"Invalid config.epochs"),t=null==e.batchSize?32:e.batchSize,r=e.windowHopRatio||DEFAULT_WINDOW_HOP_RATIO,a=__read(this.collectTransferDataAsTfDataset(r,e.validationSplit,t),2),n=a[0],s=a[1],i=util.now(),[4,this.model.fitDataset(n,{epochs:e.epochs,validationData:e.validationSplit>0?s:null,callbacks:null==e.callback?null:[e.callback]})];case 1:return o=c.sent(),console.log("fitDataset() took "+(util.now()-i).toFixed(2)+" ms"),null!=e.fineTuningEpochs&&e.fineTuningEpochs>0?(l=util.now(),[4,this.fineTuningUsingTfDatasets(e,n,s)]):[3,3];case 2:return u=c.sent(),console.log("fitDataset() (fine-tuning) took "+(util.now()-l).toFixed(2)+" ms"),[2,[o,u]];case 3:return[2,o]}})})},t.prototype.trainOnTensors=function(e){return __awaiter(this,void 0,void 0,function(){var t,r,a,n,s,i,o,l,u,c;return __generator(this,function(h){switch(h.label){case 0:t=e.windowHopRatio||DEFAULT_WINDOW_HOP_RATIO,r=this.collectTransferDataAsTensors(t),a=r.xs,n=r.ys,console.log("Training data: xs.shape = "+a.shape+", ys.shape = "+n.shape),h.label=1;case 1:return h.trys.push([1,,6,7]),null!=e.validationSplit?(l=balancedTrainValSplit(a,n,e.validationSplit),s=l.trainXs,i=l.trainYs,o=[l.valXs,l.valYs]):(s=a,i=n),[4,this.model.fit(s,i,{epochs:null==e.epochs?20:e.epochs,validationData:o,batchSize:e.batchSize,callbacks:null==e.callback?null:[e.callback]})];case 2:return u=h.sent(),null!=e.fineTuningEpochs&&e.fineTuningEpochs>0?[4,this.fineTuningUsingTensors(e,s,i,o)]:[3,4];case 3:return c=h.sent(),[2,[u,c]];case 4:return[2,u];case 5:return[3,7];case 6:return dispose([a,n,s,i,o]),[7];case 7:return[2]}})})},t.prototype.fineTuningUsingTfDatasets=function(e,t,r){return __awaiter(this,void 0,void 0,function(){var a,n,s;return __generator(this,function(i){switch(i.label){case 0:return a=this.secondLastBaseDenseLayer.trainable,this.secondLastBaseDenseLayer.trainable=!0,n=null==e.fineTuningOptimizer?"sgd":e.fineTuningOptimizer,this.model.compile({loss:"categoricalCrossentropy",optimizer:n,metrics:["acc"]}),[4,this.model.fitDataset(t,{epochs:e.fineTuningEpochs,validationData:r,callbacks:null==e.callback?null:[e.callback]})];case 1:return s=i.sent(),this.secondLastBaseDenseLayer.trainable=a,[2,s]}})})},t.prototype.fineTuningUsingTensors=function(e,t,r,a){return __awaiter(this,void 0,void 0,function(){var n,s,i;return __generator(this,function(o){switch(o.label){case 0:return n=this.secondLastBaseDenseLayer.trainable,this.secondLastBaseDenseLayer.trainable=!0,s=null==e.fineTuningOptimizer?"sgd":e.fineTuningOptimizer,this.model.compile({loss:"categoricalCrossentropy",optimizer:s,metrics:["acc"]}),[4,this.model.fit(t,r,{epochs:e.fineTuningEpochs,validationData:a,batchSize:e.batchSize,callbacks:null==e.fineTuningCallback?null:[e.fineTuningCallback]})];case 1:return i=o.sent(),this.secondLastBaseDenseLayer.trainable=n,[2,i]}})})},t.prototype.evaluate=function(e){return __awaiter(this,void 0,void 0,function(){var t,r=this;return __generator(this,function(a){return util.assert(null!=e.wordProbThresholds&&e.wordProbThresholds.length>0,"Received null or empty wordProbThresholds"),t=0,util.assert(this.words[t]===BACKGROUND_NOISE_TAG,"Cannot perform evaluation when the first tag is not "+BACKGROUND_NOISE_TAG),[2,tidy(function(){for(var a=[],n=0,s=r.collectTransferDataAsTensors(e.windowHopRatio),i=s.xs,o=s.ys.argMax(-1).dataSync(),l=r.model.predict(i),u=l.slice([0,1],[l.shape[0],l.shape[1]-1]).max(-1),c=l.shape[0],h=0;h<e.wordProbThresholds.length;++h){for(var d=e.wordProbThresholds[h],p=u.greater(scalar(d)).dataSync(),f=0,m=0,g=0,v=0,y=0;y<c;++y)o[y]===t?(f++,p[y]&&g++):(m++,p[y]&&v++);var b=g/f,w=v/m;a.push({probThreshold:d,fpr:b,tpr:w}),console.log("ROC thresh="+d+": fpr="+b.toFixed(4)+", tpr="+w.toFixed(4)),h>0&&(n+=Math.abs(a[h-1].fpr-a[h].fpr)*(a[h-1].tpr+a[h].tpr)/2)}return{rocCurve:a,auc:n}})]})})},t.prototype.createTransferModelFromBaseModel=function(){util.assert(null!=this.words,"No word example is available for tranfer-learning model of name "+this.name);for(var e=this.baseModel.layers,t=e.length-2;t>=0&&"dense"!==e[t].getClassName().toLowerCase();)t--;if(t<0)throw new Error("Cannot find a hidden dense layer in the base model.");this.secondLastBaseDenseLayer=e[t];var r=this.secondLastBaseDenseLayer.output;this.transferHead=sequential(),this.transferHead.add(layers.dense({units:this.words.length,activation:"softmax",inputShape:r.shape.slice(1)}));var a=this.transferHead.apply(r);this.model=model({inputs:this.baseModel.inputs,outputs:a})},t.prototype.modelInputShape=function(){return this.baseModel.inputs[0].shape},t.prototype.getMetadata=function(){return{tfjsSpeechCommandsVersion:version,modelName:this.name,timeStamp:(new Date).toISOString(),wordLabels:this.wordLabels()}},t.prototype.save=function(e){return __awaiter(this,void 0,void 0,function(){var t,r,a;return __generator(this,function(n){return t=null!=e,e=e||getCanonicalSavePath(this.name),t||(r=localStorageWrapper.localStorage.getItem(SAVED_MODEL_METADATA_KEY),(a=null==r?{}:JSON.parse(r))[this.name]=this.getMetadata(),localStorageWrapper.localStorage.setItem(SAVED_MODEL_METADATA_KEY,JSON.stringify(a))),console.log("Saving model to "+e),[2,this.model.save(e)]})})},t.prototype.load=function(e){return __awaiter(this,void 0,void 0,function(){var t,r,a;return __generator(this,function(n){switch(n.label){case 0:if(t=null!=e,e=e||getCanonicalSavePath(this.name),!t){if(null==(r=JSON.parse(localStorageWrapper.localStorage.getItem(SAVED_MODEL_METADATA_KEY)))||null==r[this.name])throw new Error("Cannot find metadata for transfer model named "+this.name+'"');this.words=r[this.name].wordLabels,console.log("Loaded word list for model named "+this.name+": "+this.words)}return a=this,[4,loadModel(e)];case 1:return a.model=n.sent(),console.log("Loaded model from "+e+":"),this.model.summary(),[2]}})})},t.prototype.createTransfer=function(e){throw new Error("Creating transfer-learned recognizer from a transfer-learned recognizer is not supported.")},t}(BrowserFftSpeechCommandRecognizer);function getCanonicalSavePath(e){return""+SAVE_PATH_PREFIX+e}function listSavedTransferModels(){return __awaiter(this,void 0,void 0,function(){var e,t,r;return __generator(this,function(a){switch(a.label){case 0:return[4,io.listModels()];case 1:for(r in e=a.sent(),t=[],e)r.startsWith(SAVE_PATH_PREFIX)&&t.push(r.slice(SAVE_PATH_PREFIX.length));return[2,t]}})})}function deleteSavedTransferModel(e){return __awaiter(this,void 0,void 0,function(){var t;return __generator(this,function(r){switch(r.label){case 0:return null==(t=JSON.parse(localStorageWrapper.localStorage.getItem(SAVED_MODEL_METADATA_KEY)))&&(t={}),null!=t[e]&&delete t[e],localStorageWrapper.localStorage.setItem(SAVED_MODEL_METADATA_KEY,JSON.stringify(t)),[4,io.removeModel(getCanonicalSavePath(e))];case 1:return r.sent(),[2]}})})}function create(e,t,r,a){if(util.assert(null==r&&null==a||null!=r&&null!=a,"customModelURL and customMetadataURL must be both provided or both not provided."),null!=r&&util.assert(null==t,"vocabulary name must be null or undefined when modelURL is provided"),"BROWSER_FFT"===e)return new BrowserFftSpeechCommandRecognizer(t,r,a);throw"SOFT_FFT"===e?new Error("SOFT_FFT SpeechCommandRecognizer has not been implemented yet."):new Error("Invalid fftType: '"+e+"'")}export{create,BACKGROUND_NOISE_TAG,Dataset,getMaxIntensityFrameIndex,spectrogram2IntensityCurve,deleteSavedTransferModel,listSavedTransferModels,UNKNOWN_TAG,version};
//# sourceMappingURL=speech-commands.esm.js.map
